const { dao } = require('./contracts');

const addPostWithRetry = async (authors, hash, citations, retryDelay = 5000) => {
  try {
    await dao.addPost(authors, hash, citations);
  } catch (e) {
    if (e.code === 'REPLACEMENT_UNDERPRICED') {
      console.log('retry delay (sec):', retryDelay / 1000);
      await Promise.delay(retryDelay);
      return addPostWithRetry(authors, hash, citations, retryDelay * 2);
    } if (e.reason === 'A post with this postId already exists') {
      return { alreadyAdded: true };
    }
    throw e;
  }
  return { alreadyAdded: false };
};

module.exports = addPostWithRetry;
